import java.awt.Color;

public class Particule {
	public Double x;
	public Double y;
	public Double z;
	public Double rayon;
	public Double rapportSNR;
	public Double norme;

	public Particule plusProcheVoisin;
	public Double vitesse;
	public Boolean dejaVoisin;
	public int nbVoisin;
	public Color color;

	Particule(Double x, Double y, Double z, Double rayon, Double rapportSNR) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.rayon = rayon;
		this.rapportSNR = rapportSNR;
		this.color = Color.GRAY;

		this.plusProcheVoisin = null;
		this.vitesse = 0.0;
		this.dejaVoisin = false;
		this.nbVoisin = 0;
		this.norme = Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2) + Math.pow(z, 2));
	}

	public void ajouterVoisin(Particule p2) {
		if (!this.estEgal(p2)) {
			this.plusProcheVoisin = p2;
			this.dejaVoisin = true;
			this.nbVoisin++;
		}
	}

	public void enleverVoisin() {
		this.plusProcheVoisin = null;
		this.dejaVoisin = false;
	}

	public boolean estEgal(Particule p2) {
		if (this.x != p2.x || this.y != p2.y || this.z != p2.z)
			return false;
		return true;
	}

	public String toString() {
		String retour = "";
		retour += "x : " + this.x + "\n";
		retour += "y : " + this.y + "\n";
		retour += "z : " + this.z + "\n";
		retour += "Color : " + this.color + "\n";
		retour += "rayon : " + this.rayon + "\n";
		retour += "rapportSNR : " + this.rapportSNR + "\n";
		return retour;
	}
}
